Attribute VB_Name = "Wrapper"
'============================================================================
'   aPCI-P31B
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   V1.11 Date 1999/08/23
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA31B_DLL_NAME = "aisa31b.dll" ' DLL
Global Const AISA31B_ERR_WRAPDLL = -1        ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     aisa31b.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwDllOpen() As Boolean
  Aisa31bwDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(AISA31B_DLL_NAME)
    If hDLL <> 0 Then
      Aisa31bwDllOpen = Aisa31bwGetDllExportFunc()
      If Aisa31bwDllOpen <> True Then
        Aisa31bwDllClose       ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     aisa31b.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwDllClose() As Boolean
  Aisa31bwDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Aisa31bwDllClose = True
    End If
  End If
End Function
'============================================================================
'     aISA-P31B DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion    DLLްޮݔԍi[
'         pdwDriverVersion ޲ײްްޮݔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
  Aisa31bwGetVersion = False
  If hDLL <> 0 Then
    If Aisa31bGetVersion(pdwDllVersion, pdwDriverVersion) <> 0 Then
      Aisa31bwGetVersion = True
    End If
  End If
End Function
'============================================================================
'     aISA-P31B̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwCreate(pwLogSlot As Integer) As Boolean
  Aisa31bwCreate = False
  If hDLL <> 0 Then
    If Aisa31bCreate(pwLogSlot) <> 0 Then
      Aisa31bwCreate = True
    End If
  End If
End Function
'============================================================================
'     aISA-P31B̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwClose(ByVal wLogSlot As Integer) As Boolean
  Aisa31bwClose = False
  If hDLL <> 0 Then
    If Aisa31bClose(wLogSlot) <> 0 Then
      Aisa31bwClose = True
    End If
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwGetResource(ByVal wLogSlot As Integer, pResInfo As AISA31BRESOURCE) As Boolean
  Aisa31bwGetResource = False
  If hDLL <> 0 Then
    If Aisa31bGetResource(wLogSlot, pResInfo) <> 0 Then
      Aisa31bwGetResource = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
  Aisa31bwInPort = False
  If hDLL <> 0 Then
    If Aisa31bInPort(wLogSlot, dwLogPort, pbInValue) <> 0 Then
      Aisa31bwInPort = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Aisa31bwOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
  Aisa31bwOutPort = False
  If hDLL <> 0 Then
    If Aisa31bOutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
      Aisa31bwOutPort = True
    End If
  End If
End Function
'============================================================================
'     aISA-P31B̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Aisa31bwGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Aisa31bwGetLastError = AISA31B_ERR_WRAPDLL
  Else
    Aisa31bwGetLastError = Aisa31bGetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Aisa31bwGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Aisa31bwGetDllExportFunc = False
  ' Aisa31bGetVersion ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bGetVersion")
  If pFunc = 0 Then Exit Function
  ' Aisa31bCreate ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bCreate")
  If pFunc = 0 Then Exit Function
  ' Aisa31bClose ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bClose")
  If pFunc = 0 Then Exit Function
  ' Aisa31bGetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bGetResource")
  If pFunc = 0 Then Exit Function
  ' Aisa31bInPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bInPort")
  If pFunc = 0 Then Exit Function
  ' Aisa31bOutPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bOutPort")
  If pFunc = 0 Then Exit Function
  ' Aisa31bGetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Aisa31bGetLastError")
  If pFunc = 0 Then Exit Function
  Aisa31bwGetDllExportFunc = True    ' SĂ DLL ߰Ċ֐ڽ擾
End Function



